#include <windows.h>
#include <commctrl.h>

#define CLASSNAME "EdgesClass"

HWND ctlstyle[32];

void UpdateRect(HWND hwnd)
{
  unsigned int style;
  int i, s;
  RECT r;
  HDC hdc;

  r.left = 50;
  r.top = 25;
  r.right = 200;
  r.bottom = 175;

  hdc = GetDC(hwnd);

  style = 0;
  for (i = 0; i < 32; ++i)
  {
    s = SendMessage(ctlstyle[i], BM_GETCHECK, 0, 0);
    if (s == BST_CHECKED)
      style |= 1 << (31 - i);
  }

  SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0, 0, 0)));
  MoveToEx(hdc, 50 - 2, 25 - 2, NULL);
  LineTo(hdc, 200 + 1, 25 - 2);
  LineTo(hdc, 200 + 1, 175 + 1);
  LineTo(hdc, 50 - 2, 175 + 1);
  LineTo(hdc, 50 - 2, 25 - 2);
  FillRect(hdc, &r, GetSysColorBrush(COLOR_BACKGROUND));
  DrawEdge(hdc, &r, style, BF_RECT);
  ReleaseDC(hwnd, hdc);
}

void CreateControls(HWND hwnd)
{
  int i, j;
  int x, y;
  HDC hdc;

  x = 50;
  y = 200;
  for (j = 0; j < 4; ++j)
  {
    for (i = 0; i < 8; ++i)
    {
      ctlstyle[j * 8 + i] = CreateWindow("BUTTON", "",
                                 WS_VISIBLE | WS_CHILD
                                 | BS_AUTOCHECKBOX,
                                 x, y, 13, 13,
                                 hwnd,
                                 (HMENU) NULL,
                                 (HINSTANCE) NULL,
                                 (LPVOID) NULL);
      x += 20;
    }
    y += 20;
    x = 50;
  }

  hdc = GetDC(hwnd);
  SelectObject(hdc, CreatePen(PS_SOLID, 0, RGB(0, 0, 0)));
  MoveToEx(hdc, 50 - 1, 25 - 1, NULL);
  LineTo(hdc, 200, 25 - 1);
  LineTo(hdc, 200, 175);
  LineTo(hdc, 50 - 1, 175);
  LineTo(hdc, 50 - 1, 25 - 1);
  ReleaseDC(hwnd, hdc);
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    case WM_CREATE:
      CreateControls(hwnd);
    break;
    case WM_CLOSE:
      DestroyWindow(hwnd);
    break;
    case WM_DESTROY:
      PostQuitMessage(0);
    break;
    case WM_COMMAND:
      if (HIWORD(wParam) == BN_CLICKED)
        UpdateRect(hwnd);
    break;
    default:
      return DefWindowProc(hwnd, msg, wParam, lParam);
  }
  return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASS wc;
  HWND hwnd;
  MSG Msg;
  int x, y, width, height;

  wc.style = 0;
  wc.lpfnWndProc = WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = CLASSNAME;

  RegisterClass(&wc);

  width = 250 + 2 * GetSystemMetrics(SM_CXFRAME);
  height = 300 + 2 * GetSystemMetrics(SM_CYFRAME) + GetSystemMetrics(SM_CYCAPTION);

  x = (GetSystemMetrics(SM_CXSCREEN) - width) / 2;
  y = (GetSystemMetrics(SM_CYSCREEN) - height) / 2;

  hwnd = CreateWindow(
    CLASSNAME,
    "Edges",
    WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
    NULL, NULL, hInstance, NULL);

  MoveWindow(hwnd, x, y, width, height,FALSE);

  ShowWindow(hwnd, nCmdShow);

  while(GetMessage(&Msg, NULL, 0, 0) > 0)
  {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
  }

  return Msg.wParam;
}

